package org.example;

import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import static jakarta.servlet.http.HttpServletResponse.SC_OK;

@WebServlet("/chat")
public class ChatServlet extends HttpServlet {

	private static final List<String> messages = new ArrayList<>();

	@Override
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setStatus(SC_OK);
		response.setContentType("text/html");
		try (PrintWriter out = response.getWriter()) {
			out.println("<!DOCTYPE html>");
			out.println("<html>");
			out.println("<head>");
			out.println("    <meta charset='utf-8'>");
			out.println("    <title>Chat Servlet</title>");
			out.println("    <link rel='stylesheet' href='styles.css'>");
			out.println("</head>");
			out.println("<body>");
			out.println("    <h1>Chat</h1>");
			out.println("    <form action='chat' method='post'>");
			out.println("    	<label>Your Message:</label>");
			out.println("    	<input type='text' name='message' size='40' required>");
			out.println("    	<input type='submit' value='Post'>");
			out.println("    </form>");
			out.println("    <br>");
			for (String message : messages) {
				out.println("    <p>" + message + "</p>");
			}
			out.println("</body>");
			out.println("</html>");
		}
	}

	@Override
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String message = request.getParameter("message");
		messages.add(message);
		doGet(request, response);
	}
}
